unit USample;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.TMSFNCTypes, FMX.TMSFNCUtils, FMX.TMSFNCGraphics, FMX.TMSFNCGraphicsTypes,
  FMX.TMSFNCGridCell, FMX.TMSFNCGridOptions, FMX.TMSFNCCustomControl,
  FMX.TMSFNCCustomScrollControl, FMX.TMSFNCGridData, FMX.TMSFNCCustomGrid,
  FMX.TMSFNCGrid, FMX.StdCtrls, FMX.Controls.Presentation;

type
  TForm22 = class(TForm)
    TMSFNCGrid1: TTMSFNCGrid;
    Panel1: TPanel;
    Label1: TLabel;
    procedure TMSFNCGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure TMSFNCGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Single);
    procedure TMSFNCGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Panel1DragOver(Sender: TObject; const Data: TDragObject;
      const Point: TPointF; var Operation: TDragOperation);
    procedure Panel1DragDrop(Sender: TObject; const Data: TDragObject;
      const Point: TPointF);
    procedure FormCreate(Sender: TObject);
    procedure TMSFNCGrid1MouseLeave(Sender: TObject);
    procedure TMSFNCGrid1MouseEnter(Sender: TObject);
    procedure TMSFNCGrid1DragLeave(Sender: TObject);
  private
    { Private declarations }
      FMouseDown, FDraggingStarted, FMouseInGrid: Boolean;
      FMousePos: TPointF;
  public
    { Public declarations }
  end;

var
  Form22: TForm22;

implementation

{$R *.fmx}

type
  TTMSFNCGridDrag = class(TTMSFNCGrid);

procedure TForm22.FormCreate(Sender: TObject);
begin
  TMSFNCGrid1.Options.Editing.Enabled := False;
  TMSFNCGrid1.RandomFill;
end;

procedure TForm22.Panel1DragDrop(Sender: TObject; const Data: TDragObject;
  const Point: TPointF);
var
  c: TTMSFNCGridCellRec;
begin
  if Data.Source is TTMSFNCGrid then
  begin
    c := (Data.Source as TTMSFNCGrid).FocusedCell;
    if (c.Col <> -1) and (c.Row <> -1) then
      Label1.Text := TMSFNCGrid1.Cells[c.Col, c.Row];
  end;
end;

procedure TForm22.Panel1DragOver(Sender: TObject; const Data: TDragObject;
  const Point: TPointF; var Operation: TDragOperation);
begin
  if Data.Source is TTMSFNCGrid then
  begin
    Operation := TDragOperation.Copy;
  end;
end;

procedure TForm22.TMSFNCGrid1DragLeave(Sender: TObject);
begin
  TTMSFNCGridDrag(TMSFNCGrid1).MouseUp(TMouseButton.mbLeft, [], 0, 0);
end;

procedure TForm22.TMSFNCGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FMouseDown := True;
  FDraggingStarted := False;
  FMousePos := PointF(X, Y);
end;

procedure TForm22.TMSFNCGrid1MouseEnter(Sender: TObject);
begin
  FMouseInGrid := True;
end;

procedure TForm22.TMSFNCGrid1MouseLeave(Sender: TObject);
begin
  FMouseInGrid := False;
end;

procedure TForm22.TMSFNCGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);
var
  c: TTMSFNCGridCellRec;
begin
  if FMouseDown and FMouseInGrid and not FDraggingStarted then
  begin
    c := TMSFNCGrid1.XYToCell(X, Y);
    if (c.Col <> -1) and (c.Row <> -1) then
    begin
      if (Abs(X - FMousePos.X) >= 5) or (Abs(Y - FMousePos.Y) >= 5) then
      begin
        FDraggingStarted := True;
        TTMSFNCGridDrag(TMSFNCGrid1).BeginDrag;
      end;
    end;
  end;
end;

procedure TForm22.TMSFNCGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  FMouseDown := False;
  FDraggingStarted := False;
end;

end.
